OSDN Git Service

2014-05-07 Richard Biener <rguenther@suse.de>
[pf3gnuchains/gcc-fork.git] / contrib / gcc_update
1 #! /bin/sh
2 #
3 # Update a local Subversion, Git or Mercurial tree from the GCC
4 # repository, with an emphasis on treating generated files correctly, so
5 # that autoconf, gperf et al are not required for the ``end'' user.
6 #
7 # (C) 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2009, 2010,
8 # 2011 Free Software Foundation
9 # Originally by Gerald Pfeifer <pfeifer@dbai.tuwien.ac.at>, August 1998.
10 #
11 # This script is Free Software, and it can be copied, distributed and
12 # modified as defined in the GNU General Public License.  A copy of
13 # its license can be downloaded from http://www.gnu.org/copyleft/gpl.html
14 #
15 #
16 # By default all command-line options are passed to `svn update` or `hg/git
17 # pull` in addition to $UPDATE_OPTIONS (defined below). If the first parameter
18 # reads --nostdflags, $UPDATE_OPTIONS as well as this parameter itself
19 # are omitted.
20 #
21 # If the first parameter reads --patch, the second parameter is considered
22 # a patch file.
23 #
24 # If the first parameter is --touch, no svn operation will be performed,
25 # only generated files that appear to be out of date in the local tree
26 # will be touched.
27 #
28 # If the first parameter is --list, a list of the generated files and
29 # their dependencies will be printed; --help prints this message.
30 #
31 # If the first parameter is --silent, this script prints nothing other
32 # than error messages; the second parameter is then interpreted as above.
33 #
34 # Examples:
35 #
36 # contrib/gcc_update -r 8712
37 # contrib/gcc_update --patch some-patch
38 # contrib/gcc_update --touch
39 # contrib/gcc_update --list
40
41
42 # Default options used when updating (none).
43 UPDATE_OPTIONS=""
44
45 # Set the locale to C to make this script work for users with foreign
46 # locale like e.g. French UTF-8.
47 LANG=C
48 LC_ALL=C
49 export LANG LC_ALL
50
51 ######## Anything below shouldn't be changed by regular users.
52
53 # Arrange for the value of $0 to be available for functions
54 self=$0
55
56 # This function prints its arguments to standard output unless
57 # "silent" is set.
58 unset silent
59 chat () {
60     if [ -z "$silent" ]; then
61         echo "$@"
62     fi
63 }
64
65 # This function prints a list of all generated files, along with their
66 # dependencies.  Note that only one target is supported per line: the
67 # colon is stripped from the output.
68 files_and_dependencies () {
69     sed -e 's/ *#.*//' -e '/^$/d' -e 's/://' <<\EOF
70 # fixincludes
71 fixincludes/configure: fixincludes/configure.ac fixincludes/aclocal.m4
72 fixincludes/config.h.in: fixincludes/configure.ac fixincludes/aclocal.m4
73 # intl library
74 intl/plural.c: intl/plural.y
75 intl/configure: intl/configure.ac intl/aclocal.m4
76 intl/config.h.in: intl/configure.ac intl/aclocal.m4
77 # Now, proceed to gcc automatically generated files
78 gcc/configure: gcc/configure.ac
79 gcc/cstamp-h.in: gcc/configure.ac
80 gcc/config.in: gcc/cstamp-h.in
81 gcc/fixinc/fixincl.x: gcc/fixinc/fixincl.tpl gcc/fixinc/inclhack.def
82 gcc/config/arm/arm-tune.md: gcc/config/arm/arm-cores.def gcc/config/arm/gentune.sh
83 gcc/config/arm/arm-tables.opt: gcc/config/arm/arm-arches.def gcc/config/arm/arm-cores.def gcc/config/arm/arm-fpus.def gcc/config/arm/genopt.sh
84 gcc/config/avr/avr-tables.opt: gcc/config/avr/avr-mcus.def gcc/config/avr/genopt.sh
85 gcc/config/avr/t-multilib: gcc/config/avr/avr-mcus.def gcc/config/avr/genmultilib.awk
86 gcc/config/c6x/c6x-tables.opt: gcc/config/c6x/c6x-isas.def gcc/config/c6x/genopt.sh
87 gcc/config/c6x/c6x-sched.md: gcc/config/c6x/c6x-sched.md.in gcc/config/c6x/gensched.sh
88 gcc/config/c6x/c6x-mult.md: gcc/config/c6x/c6x-mult.md.in gcc/config/c6x/genmult.sh
89 gcc/config/m68k/m68k-tables.opt: gcc/config/m68k/m68k-devices.def gcc/config/m68k/m68k-isas.def gcc/config/m68k/m68k-microarchs.def gcc/config/m68k/genopt.sh
90 gcc/config/mips/mips-tables.opt: gcc/config/mips/mips-cpus.def gcc/config/mips/genopt.sh
91 gcc/config/rs6000/rs6000-tables.opt: gcc/config/rs6000/rs6000-cpus.def gcc/config/rs6000/genopt.sh
92 gcc/config/tilegx/mul-tables.c: gcc/config/tilepro/gen-mul-tables.cc
93 gcc/config/tilepro/mul-tables.c: gcc/config/tilepro/gen-mul-tables.cc
94 # And then, language-specific files
95 gcc/cp/cfns.h: gcc/cp/cfns.gperf
96 gcc/java/keyword.h: gcc/java/keyword.gperf
97 # testsuite
98 # Without this, _Pragma3.c can have a false negative.
99 gcc/testsuite/gcc.dg/cpp/_Pragma3.c: gcc/testsuite/gcc.dg/cpp/mi1c.h
100 # Similarly, without this, you will see:
101 # direct2s.c:35: warning: current file is older than direct2.c
102 gcc/testsuite/gcc.dg/cpp/direct2s.c: gcc/testsuite/gcc.dg/cpp/direct2.c
103 # lto-plugin
104 lto-plugin/configure: lto-plugin/configure.ac lto-plugin/aclocal.m4
105 lto-plugin/Makefile.in: lto-plugin/Makefile.am lto-plugin/aclocal.m4
106 # And libraries, at last
107 libbanshee/configure: libbanshee/configure.ac
108 libmudflap/configure: libmudflap/configure.ac
109 libobjc/configure: libobjc/configure.ac
110 zlib/aclocal.m4: zlib/configure.ac zlib/acinclude.m4
111 zlib/Makefile.in: zlib/Makefile.am zlib/configure.ac zlib/aclocal.m4
112 zlib/configure: zlib/configure.ac zlib/aclocal.m4
113 fastjar/aclocal.m4: fastjar/configure.ac
114 fastjar/Makefile.in: fastjar/Makefile.am fastjar/configure.ac fastjar/aclocal.m4
115 fastjar/configure: fastjar/configure.ac fastjar/aclocal.m4
116 boehm-gc/aclocal.m4: boehm-gc/configure.ac
117 boehm-gc/Makefile.in: boehm-gc/Makefile.am boehm-gc/configure.ac boehm-gc/aclocal.m4
118 boehm-gc/configure: boehm-gc/configure.ac boehm-gc/aclocal.m4
119 libada/configure: libada/configure.ac
120 libffi/aclocal.m4: libffi/configure.ac libffi/acinclude.m4
121 libffi/Makefile.in: libffi/Makefile.am libffi/configure.ac libffi/aclocal.m4
122 libffi/configure: libffi/configure.ac libffi/aclocal.m4
123 libffi/fficonfig.h.in: libffi/configure.ac libffi/aclocal.m4
124 libgfortran/aclocal.m4: libgfortran/configure.ac libgfortran/acinclude.m4
125 libgfortran/Makefile.in: libgfortran/Makefile.am libgfortran/configure.ac libgfortran/aclocal.m4
126 libgfortran/configure: libgfortran/configure.ac libgfortran/aclocal.m4
127 libjava/aclocal.m4: libjava/configure.ac
128 libjava/Makefile.in: libjava/Makefile.am libjava/configure.ac libjava/aclocal.m4
129 libjava/configure: libjava/configure.ac libjava/aclocal.m4
130 libjava/libltdl/aclocal.m4: libjava/libltdl/configure.ac libjava/libltdl/acinclude.m4
131 libjava/libltdl/Makefile.in: libjava/libltdl/Makefile.am libjava/libltdl/configure.ac libjava/libltdl/aclocal.m4
132 libjava/libltdl/configure: libjava/libltdl/configure.ac libjava/libltdl/aclocal.m4
133 libjava/libltdl/config-h.in: libjava/libltdl/configure.ac libjava/libltdl/aclocal.m4
134 libcpp/aclocal.m4: libcpp/configure.ac
135 libcpp/Makefile.in: libcpp/configure.ac libcpp/aclocal.m4
136 libcpp/configure: libcpp/configure.ac libcpp/aclocal.m4
137 libgomp/aclocal.m4: libgomp/configure.ac libgomp/acinclude.m4
138 libgomp/Makefile.in: libgomp/Makefile.am libgomp/aclocal.m4
139 libgomp/testsuite/Makefile.in: libgomp/Makefile.am libgomp/aclocal.m4
140 libgomp/configure: libgomp/configure.ac libgomp/aclocal.m4
141 libgomp/config.h.in: libgomp/configure.ac libgomp/aclocal.m4
142 libitm/aclocal.m4: libitm/configure.ac libitm/acinclude.m4
143 libitm/Makefile.in: libitm/Makefile.am libitm/aclocal.m4
144 libitm/testsuite/Makefile.in: libitm/testsuite/Makefile.am libitm/aclocal.m4
145 libitm/configure: libitm/configure.ac libitm/aclocal.m4
146 libitm/config.h.in: libitm/configure.ac libitm/aclocal.m4
147 # Top level
148 Makefile.in: Makefile.tpl Makefile.def
149 configure: configure.ac config/acx.m4
150 EOF
151 }
152
153
154 # This function touches generated files such that the ``end'' user does
155 # not have to rebuild them.
156 touch_files () {
157     rm -f Makefile.$$
158     echo 'all: \' > Makefile.$$
159     files_and_dependencies | sed 's, .*, \\,' >> Makefile.$$
160     echo '; @true' >> Makefile.$$
161     files_and_dependencies | sed 's, ,: ,' >> Makefile.$$
162     files_and_dependencies | sed 's, .*, \\,' >> Makefile.$$
163     echo ':' >> Makefile.$$
164     echo '      @for f in $? $@; do test -f $$f || exit 0; done; \' >> Makefile.$$
165     echo '      echo Touching $@...; \' >> Makefile.$$
166     chat '      echo Touching $@... 1>&2; \' >> Makefile.$$
167     echo '      touch $@' >> Makefile.$$
168     files_and_dependencies | sed 's,[^ ]* ,,;s,$, :,' >> Makefile.$$
169
170     # We would have to explicitly shut off the "Entering... Leaving..."
171     # messages through "--no-print-directory" to handle the case when
172     # we were called from a recursive invocation (i.e. "$(MAKE)" in a
173     # Makefile, not just make).  Passing only "-s" doesn't help then,
174     # because make has helpfully added "-w" to MAKEFLAGS automatically.
175     # Unfortunately we do not require GNU make other than for building
176     # and testing, so let's just grep known text explicitly echoed by
177     # the rule.
178     while ${MAKE-make} -s -f Makefile.$$ all | grep Touching > /dev/null; do
179       sleep 1
180     done 2>&1
181     rm -f Makefile.$$
182 }
183
184
185 # Whenever we update the tree or install a patch, we may be modifying
186 # this script.  By re-execing it, we ensure that the appropriate
187 # dependencies and rules will be used.
188 touch_files_reexec () {
189     chat "Adjusting file timestamps"
190     exec ${CONFIG_SHELL-/bin/sh} $self ${silent+"--silent"} --touch
191 }
192
193 # This functions applies a patch to an existing tree.
194 apply_patch () {
195     if [ -f "$1" ]; then
196         echo "Applying patch file $1"
197         case $1 in
198         *gz)
199             gzip -d -c "$1" | patch -p1 ;;
200         *bz2)
201             bzip2 -d -c "$1" | patch -p1 ;;
202         *)
203             patch -p1 < "$1";;
204         esac
205     fi
206     touch_files_reexec
207 }
208
209 # Check whether this indeed looks like a local tree.
210 if [ ! -f gcc/version.c ]; then
211     echo "This does not seem to be a GCC tree!"
212     exit
213 fi
214
215 case "$1" in
216 --silent)
217     silent=t
218     shift
219     ;;
220 esac
221
222 case "$1" in
223 # First of all, check whether we are going to process a patch.
224 --patch)
225     if test "$#" != 2; then
226         echo "$1" expects only one argument >&2
227         exit 1
228     fi
229     apply_patch "${2}"
230     exit $?
231     ;;
232
233 --touch)
234     if test "$#" != 1; then
235         echo "$1" does not expect any argument >&2
236         exit 1
237     fi
238     touch_files
239     exit $?
240     ;;
241
242 --list)
243     if test "$#" != 1; then
244         echo "$1" does not expect any argument >&2
245         exit 1
246     fi
247     files_and_dependencies | sed 's/ /: /'
248     exit $?
249     ;;
250
251 --help)
252     sed -e '1,2d' -e '/^UPDATE_OPTIONS=/{i\
253 \
254
255 p
256 }' \
257         -e '/^$/,$d' -e 's/#//' -e 's/^ //' < $0
258     exit $?
259     ;;
260
261 esac
262
263 # Check for known version control systems.
264 if [ -d .git ]; then
265     GCC_GIT=${GCC_GIT-${GIT-git}}
266     vcs_type="git"
267 elif [ -d .hg ]; then
268     GCC_HG=${GCC_HG-${HG-hg}}
269     vcs_type="hg"
270 elif [ -d .svn ]; then
271     GCC_SVN=${GCC_SVN-${SVN-svn}}
272     vcs_type="svn"
273 else
274     echo "This does not seem to be a GCC GIT/HG/SVN tree!"
275     exit
276 fi
277
278 # Check command-line options
279 if [ x"${1}"x = x"--nostdflags"x ]; then
280     shift
281 else
282     set -- $UPDATE_OPTIONS ${1+"$@"}
283 fi
284
285 case $vcs_type in
286     git)
287         chat "Updating GIT tree"
288
289         $GCC_GIT diff --quiet --exit-code HEAD
290         if [ $? -ne 0 ]; then
291             echo "Attempting to update a dirty git tree!" >&2
292             echo "Commit or stash your changes first and retry." >&2
293             exit 1
294         fi
295
296         $GCC_GIT pull ${silent+-q} --rebase ${1+"$@"}
297         if [ $? -ne 0 ]; then
298             (touch_files_reexec)
299             echo "git pull of full tree failed." >&2
300             exit 1
301         fi
302
303         revision=`$GCC_GIT log -n1 --pretty=%p:%t:%H`
304         branch=`$GCC_GIT name-rev --name-only HEAD || :`
305         ;;    
306
307     hg)
308         chat "Updating HG tree"
309
310         # Add -q so untracked files aren't listed.
311         if [ `$GCC_HG status -q | wc -l` -gt 0 ]; then
312             echo "Attempting to update a dirty hg tree!" >&2
313             echo "Commit or revert your changes first and retry." >&2
314             exit 1
315         fi
316
317         # Check for mq extension.  mq patches must be popped so tip has
318         # been converted from the SVN tree.
319         if [ -d .hg/patches ] && [ `$GCC_HG qapplied | wc -l` -gt 0 ]; then
320             # FIXME: Perhaps pop queue instead?  We could do that since we
321             # know the tree is clean.
322             echo "Attempting to update hg tree with mq patches applied!" >&2
323             echo "Pop your patches first and retry." >&2
324             exit 1
325         fi
326
327         # Update tree, but make sure to only pull the default branch.
328         # Otherwise all branches in the upstream repo are added, even if
329         # only a single one has been cloned.
330         $GCC_HG pull ${silent+-q} -r`$GCC_HG branch` ${1+"$@"}
331         if [ $? -ne 0 ]; then
332             (touch_files_reexec)
333             echo "hg pull of full tree failed." >&2
334             exit 1
335         fi
336
337         # Update tree.  Needs to be done separately from pull so
338         # gcc_update -rREV works.
339         $GCC_HG update ${silent+-q} ${1+"$@"}
340         if [ $? -ne 0 ]; then
341             (touch_files_reexec)
342             echo "hg update of full tree failed." >&2
343             exit 1
344         fi
345
346         # Extract SVN revision corresponding to parents, as stored by
347         # hg convert.  Before hg 1.4.3, there's no template keyword
348         # corresponding to the extra: tag, so need to use hg log --debug
349         # to extract the info.
350         parents=`$GCC_HG parents --template '{rev}'`
351         convert_revision=`$GCC_HG log --debug -r$parents | \
352             sed -ne "/^extra:.*convert_revision=svn:/ {
353                 s%^[^/]*/%%
354                 p
355             }"`
356         revision=`echo $convert_revision | sed -e 's/.*@//'`
357         branch=`echo $convert_revision | sed -e 's%branches/%%' -e 's/@.*//'`
358         ;;
359
360     svn)
361         chat "Updating SVN tree"
362
363         $GCC_SVN ${silent+-q}  --non-interactive update ${1+"$@"}
364         if [ $? -ne 0 ]; then
365             (touch_files_reexec)
366             echo "SVN update of full tree failed." >&2
367             exit 1
368         fi
369
370         revision=`$GCC_SVN info | awk '/Revision:/ { print $2 }'`
371         branch=`$GCC_SVN info | sed -ne "/^URL:/ {
372             s,.*/trunk,trunk,
373             s,.*/branches/,,
374             s,.*/tags/,,
375             p
376         }"`
377         ;;
378 esac
379
380 rm -f LAST_UPDATED gcc/REVISION
381 {
382     date
383     echo "`TZ=UTC date` (revision $revision)"
384 } > LAST_UPDATED
385 echo "[$branch revision $revision]" > gcc/REVISION
386
387 touch_files_reexec